#!/usr/bin/python
#
# Python script to send individual commands to FILA10G & return result to FS log
#
# Example: ./cmd2fila10g.py <command>
#          ./cmd2fila10g.py arp off   -- turn off arps
#

#IP="172.16.43.1"
#PORT=2023
IP="fila10g.jive.nl"
PORT=23

import re
import os
import sys
import socket

# Infos
def usage_exit():
    print 'Usage: cmd2fila10g.py  <command here>'
    sys.exit(-1)

# Return a socket:  conn=(ip,port)
def getSocket(conn):
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.connect((conn['ip'],conn['port']))
        s.settimeout(1.0)
        conn['socket'] = s
    except:
        print 'Connection to %s:%u failed' % (conn['ip'],conn['port'])
        return None
    return conn

# Send a command, wait for reply
def sendRcv(conn,cmdstr):
    buffer_size = 2048
    cmdstr = '\n' + cmdstr.strip() + '\n'
    conn['socket'].send(cmdstr)
    reply = ''
    try:
        while True:
            data = conn['socket'].recv(buffer_size)
            reply = reply + data
    except:
        return reply


# Prepare and send commands to FILA10G
def main(argv):
    global _cmds
    rx = re.compile(r"^(\s*|\?+,)$")

    conn_IPaddr = IP
    conn_IPport = PORT

    conn = {'ip':conn_IPaddr, 'port':conn_IPport, 'socket':None}
    conn = getSocket(conn)
    if (conn==None):
        os.system("inject_snap \'\"Error opening connection to FILA10G\'")
        sys.exit(-1)

        # First stop sending data
    # Append data source command(s)
    reply=sendRcv(conn, " ".join(argv[1:]) + '\r\n')
    lines=reply.strip('\r\n').splitlines()
    for line in lines:
        if rx.match(line) or (len(line)>0 and ord(line[0])==255):
            continue
        #print "line=",map(ord, line)
        if line[:10] != "FiLa10G % ":
            print "FiLa10G: "+line
#   reply.strip('\r\n')
#        os.system("inject_snap \'\"command sent\'")
    sys.exit(0) 

if __name__ == "__main__":
    main(sys.argv)

